#!/usr/bin/env python

import os
import pickle
import random
import sys

import lostcat

LEVEL_WIDTH = 80

if __name__ == '__main__':
    if len(sys.argv) == 1:
        filename = raw_input('Enter a filename: ')
        if not os.path.exists(filename):
            height_str = raw_input('Enter a height: ')
            figure = lostcat.LevelFigure(width=LEVEL_WIDTH,
                                         height=int(height_str.strip()))
            with open(filename, 'wb') as fh:
                pickle.dump(figure, fh)
        args = [filename]
    else:
        args = sys.argv[1:]

    # Generate a simple test level.
    filename = args[0]
    with open(filename, 'rb') as fh:
        figure = pickle.load(fh)
    line_num = 0
    while line_num < figure.height:
        # Strata of all dirt types.
        if 6 <= line_num < 25:
            dirt = lostcat.LEVEL_DIRT_1
        elif 25 <= line_num < 35:
            dirt = lostcat.LEVEL_DIRT_2
        elif 35 <= line_num < 45:
            dirt = lostcat.LEVEL_DIRT_3
        elif 45 <= line_num < 55:
            dirt = lostcat.LEVEL_DIRT_4
        elif 55 <= line_num < 65:
            dirt = lostcat.LEVEL_DIRT_5
        else:
            dirt = lostcat.LEVEL_EMPTY

        for i in range(figure.width):
            if line_num > 7 and random.randrange(50) == 9:
                figure.set_dirt(random.randrange(5) + lostcat.LEVEL_COIN_1, i, line_num)
            else:
                figure.set_dirt(dirt, i, line_num)
        line_num += 1

    figure.add_active_object('player', 'Player', 3, 3)
    figure.add_active_object('shovel', 'Shovel', 70, 3)
    figure.add_active_object('barn', 'Barn', 74, 0)
    figure.add_active_object('mycat', 'MyCat', 60, 47)

    with open(filename, 'wb') as fh:
        pickle.dump(figure, fh)
    print 'Wrote test level to {}.'.format(filename)

    # TODO: a real editor
    #world = gameworld.GameWorld(LvlEditGame)
    #sys.exit(world.main(args))
